SystemOrganization addCategory: #Prolog!
SystemOrganization addCategory: #'Prolog-Predicate'!
SystemOrganization addCategory: #'Prolog-Test'!
SystemOrganization addCategory: #'Prolog-QueryWhat'!

TestCase subclass: #PrologExampleTest
	instanceVariableNames: 'prolog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

PrologExampleTest subclass: #AncestorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!AncestorTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!AncestorTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:46'!
setUp
super setUp.
prolog fact: #father data: {#zeb. #johnBoySr}.
prolog fact: #father data: {#johnBoySr. #johnBoyJr}.

prolog rule: #ancestor definition: [:x :y| prolog query: #father data: {x.y}].
prolog rule: #ancestor dataSize: 2 definition: [:x :y :m| (prolog query: #ancestor data: {x.m}) and: [prolog query: #ancestor data: {m.y}]].! !

!AncestorTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFather
self assert: (prolog query: #father data: {#zeb. #johnBoySr}).
self assert: (prolog query: #father data: {#johnBoySr. #johnBoyJr}).

self deny: (prolog query: #father data: {#zeb. #johnBoyJr}).
self deny: (prolog query: #father data: {#johnBoyJr. #johnBoySr}).! !

!AncestorTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFatherIsAncestor
self assert: (prolog query: #ancestor data: {#zeb. #johnBoySr}).
self assert: (prolog query: #ancestor data: {#johnBoySr. #johnBoyJr}).

self assert: (prolog query: #ancestor data: {#zeb. #johnBoyJr}).
self deny: (prolog query: #ancestor data: {#johnBoyJr. #johnBoySr}).! !

!AncestorTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testGrandFatherIsAncestor
self assert: (prolog query: #ancestor data: {#zeb. #johnBoyJr}).! !

PrologExampleTest subclass: #MapColoringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!MapColoringTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!MapColoringTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:46'!
setUp
super setUp.
prolog fact: #different data: {#red. #green}.
prolog fact: #different data: {#red. #blue}.
prolog fact: #different data: {#green. #red}.
prolog fact: #different data: {#green. #blue}.
prolog fact: #different data: {#blue. #red}.
prolog fact: #different data: {#blue. #green}.

prolog rule: #coloring
	definition: [:alabama :mississippi :georgia : tennesee :florida|
	(prolog query: #different data: {mississippi. tennesee}) and: [
	(prolog query: #different data: {mississippi. alabama}) and: [
	(prolog query: #different data: {alabama. tennesee}) and: [
	(prolog query: #different data: {alabama. mississippi}) and: [
	(prolog query: #different data: {alabama. georgia}) and: [
	(prolog query: #different data: {alabama. florida}) and: [
	(prolog query: #different data: {georgia. florida}) and: [
	(prolog query: #different data: {georgia. tennesee})]]]]]]] ].
! !

!MapColoringTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testResult
|result|
result := prolog queryWhat: #coloring data: {#A. #B. #C. #D. #E}.
self assert: result size equals: 6.
self assert: (result includes: {#blue. #red. #red. #green. #green})! !

!PrologExampleTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^true.! !

!PrologExampleTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:46'!
setUp
super setUp.
prolog := PrologKnowledgeBase new.
! !

PrologExampleTest subclass: #RunningRulesToFindAllFactsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!RunningRulesToFindAllFactsTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!RunningRulesToFindAllFactsTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:46'!
setUp
super setUp.
prolog fact: #father data: {#zeb. #johnBoySr}.
prolog fact: #father data: {#johnBoySr. #johnBoyJr}.
prolog fact: #father data: {#johnBoyJr. #son}.
prolog fact: #father data: {#son. #grandSon}.
prolog fact: #father data: {#grandSon. #grandGrandSon}.

prolog rule: #ancestor definition: [:x :y| prolog query: #father data: {x.y}].
prolog rule: #ancestor dataSize: 2 definition: [:x :y :m| (prolog query: #ancestor data: {x.m}) and: [prolog query: #ancestor data: {m.y}]].
prolog runRulesToFindAllFacts.! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFather
self assert: (prolog query: #father data: {#zeb. #johnBoySr}).
self assert: (prolog query: #father data: {#johnBoySr. #johnBoyJr}).

self deny: (prolog query: #father data: {#zeb. #johnBoyJr}).
self deny: (prolog query: #father data: {#johnBoyJr. #johnBoySr}).! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFatherIsAncestor
self assert: (prolog query: #ancestor data: {#zeb. #johnBoySr}).
self assert: (prolog query: #ancestor data: {#johnBoySr. #johnBoyJr}).

self assert: (prolog query: #ancestor data: {#zeb. #johnBoyJr}).
self deny: (prolog query: #ancestor data: {#johnBoyJr. #johnBoySr}).! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testGrandFatherIsAncestor
self assert: (prolog query: #ancestor data: {#zeb. #johnBoyJr}).! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testGrandFatherIsAncestor1
self assert: (prolog query: #ancestor data: {#zeb. #son}).! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testGrandFatherIsAncestor2
self assert: (prolog query: #ancestor data: {#zeb. #grandSon}).! !

!RunningRulesToFindAllFactsTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testGrandFatherIsAncestor3
self assert: (prolog query: #ancestor data: {#zeb. #grandGrandSon}).! !

PrologExampleTest subclass: #ThreeLikesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

ThreeLikesTest subclass: #CheeseAndSheepTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!CheeseAndSheepTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!CheeseAndSheepTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testAllLike
| searchResult |
searchResult := prolog queryWhat: #likes data: {#P. #O}.
self assert: searchResult size equals: 3.
self assert: (searchResult at: 1) equals: {#wallace. #cheese}.
self assert: (searchResult at: 2) equals: {#grommit. #cheese}.
self assert: (searchResult at: 3) equals: {#wendolene. #sheep}.! !

!CheeseAndSheepTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testEmptyResultIfNoMatch
| searchResult |
searchResult := prolog queryWhat: #likes data: {1. #W}.
self assert: searchResult size equals: 0.! !

!CheeseAndSheepTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFactsAreTrue
self assert: (prolog query: #likes data: {#wallace. #cheese}).! !

!CheeseAndSheepTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFalseIfNotAFact
self deny: (prolog query: #likes data: {#wallace. #sheep}).! !

!CheeseAndSheepTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testWhoLikesCheese
| searchResult |
searchResult := prolog queryWhat: #likes data: {#X. #cheese}.
self assert: searchResult size equals: 2.
self assert: (searchResult at: 1) equals: {#wallace}.
self assert: (searchResult at: 2) equals: {#grommit}.! !

ThreeLikesTest subclass: #FriendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!FriendTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!FriendTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:45'!
setUp
super setUp.
prolog rule: #friend
	dataSize: 2
	definition: [:p1 :p2 :thing| p1 ~= p2 and: [(prolog query: #likes data: {p1. thing}) and: [prolog query: #likes data: {p2. thing}]]].! !

!FriendTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testEnlist
|list|
list := prolog queryWhat: #friend data: {#A. #B}. 
self assert: list size equals: 2.
self assert: (list at: 1) equals: {#wallace. #grommit}.
self assert: (list at: 2) equals: {#grommit. #wallace}.! !

!FriendTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFriends
self assert: (prolog query: #friend data: {#wallace. #grommit}).! !

!FriendTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testNotFriends
self deny: (prolog query: #friend data: {#wallace. #wendolene}).! !

ThreeLikesTest subclass: #SimpleRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Test'!

!SimpleRuleTest classSide methodsFor: 'testing' stamp: 'HwaJong 10/23/2012 14:39'!
isAbstract
^false! !

!SimpleRuleTest methodsFor: 'running' stamp: 'HwaJong 10/23/2012 14:45'!
setUp
super setUp.
prolog rule: #cheeseLover dataSize: 1 definition: [:x| prolog query: #likes data: {x. #cheese}].
! !

!SimpleRuleTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testAllCheeseLover
|searchResult|
searchResult := prolog queryWhat: #cheeseLover data: {#Person}.
self assert: searchResult size equals: 2.
self assert: (searchResult at: 1) equals: {#wallace}.
self assert: (searchResult at: 2) equals: {#grommit}.! !

!SimpleRuleTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testFalse
self deny: (prolog query: #cheeseLover data: {#wendolene}).
! !

!SimpleRuleTest methodsFor: 'tests' stamp: 'HwaJong 10/23/2012 14:38'!
testTrue
self assert: (prolog query: #cheeseLover data: {#wallace}).
! !

!ThreeLikesTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/23/2012 14:43'!
isAbstract
^true! !

!ThreeLikesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/23/2012 14:46'!
setUp
super setUp.
prolog fact: #likes data: {#wallace. #cheese}.
prolog fact: #likes data: {#grommit. #cheese}.
prolog fact: #likes data: {#wendolene. #sheep}.! !

!ByteSymbol methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:12'!
representsPrologVariable
^self first isUppercase! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:01'!
isPrologVariable
^false! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:13'!
representsPrologVariable
^false! !

Object subclass: #PrologKnowledgeBase
	instanceVariableNames: 'flatGrandDomain rules factsGroupedByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologKnowledgeBase methodsFor: 'predicating' stamp: 'HwaJong 10/23/2012 14:27'!
fact: aSymbol data: anArray 
	|f|
	f := Fact factName: aSymbol data: anArray.
	(self factsAtPredicateName: aSymbol) add: f.
	flatGrandDomain addAll: f data.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/23/2012 14:25'!
factCount
^(factsGroupedByName values collect: [:each| each size]) inject: 0 into: [:sum :each| sum+ each]. ! !

!PrologKnowledgeBase methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:27'!
factsAtPredicateName: aSymbol 
	^factsGroupedByName at: aSymbol ifAbsentPut: [Set new] ! !

!PrologKnowledgeBase methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 14:08'!
flatGrandDomain
^flatGrandDomain! !

!PrologKnowledgeBase methodsFor: 'initialize-release' stamp: 'HwaJong 10/23/2012 13:59'!
initialize
super initialize.
factsGroupedByName := Dictionary new.
flatGrandDomain := Set new.! !

!PrologKnowledgeBase methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 13:59'!
predicateNames
^factsGroupedByName keys! !

!PrologKnowledgeBase methodsFor: 'query' stamp: 'HwaJong 10/23/2012 13:59'!
query: aSymbol data: anArray 
	(factsGroupedByName includesKey: aSymbol) ifFalse: [^false].
	(factsGroupedByName at: aSymbol) detect: [:each| each isTrueWithName: aSymbol data: anArray ] ifNone: [^false].
	^true! !

!PrologKnowledgeBase methodsFor: 'query' stamp: 'HwaJong 10/22/2012 18:50'!
queryWhat: aSymbol data: anArray 
^(QueryWhat knowledgeBase: self predicateName: aSymbol data: anArray) value.! !

!PrologKnowledgeBase methodsFor: 'predicating' stamp: 'HwaJong 10/23/2012 14:08'!
rule: aSymbol dataSize: anInteger definition: definitionClosure
	|r|
	r := Rule knowledgeBase: self predicateName: aSymbol dataSize: anInteger definition: definitionClosure.
	self rules addLast: r.
	r compute.! !

!PrologKnowledgeBase methodsFor: 'predicating' stamp: 'HwaJong 10/23/2012 10:36'!
rule: aSymbol definition: definitionClosure 
self rule: aSymbol dataSize: definitionClosure numArgs definition: definitionClosure! !

!PrologKnowledgeBase methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:09'!
rules
	rules isNil ifTrue: [rules := OrderedCollection new].
	^ rules! !

!PrologKnowledgeBase methodsFor: 'run rules' stamp: 'HwaJong 10/23/2012 14:25'!
runRules
self rules do: [:each| each compute]! !

!PrologKnowledgeBase methodsFor: 'run rules' stamp: 'HwaJong 10/23/2012 14:18'!
runRulesToFindAllFacts
[| factCount |
factCount := self factCount.
self runRules.
factCount = self factCount] whileFalse! !

Object subclass: #PrologPredicate
	instanceVariableNames: 'predicateName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

PrologPredicate subclass: #Fact
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

Fact class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!Fact classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:30'!
factName: aSymbol data: anArray 
^self new
	factName: aSymbol;
	data: anArray! !

!Fact methodsFor: 'accessing' stamp: 'HwaJong 10/21/2012 22:11'!
data

	^ data! !

!Fact methodsFor: 'accessing' stamp: 'HwaJong 10/21/2012 21:46'!
data: anArray 
data := anArray! !

!Fact methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 15:29'!
factName: aSymbol 
predicateName := aSymbol ! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/23/2012 14:28'!
gettersForEquality
^#(predicateName data)! !

!Fact methodsFor: 'testing' stamp: 'HwaJong 10/22/2012 15:29'!
isTrueWithName: aSymbol data: anArray 
	predicateName = aSymbol ifFalse: [^false].
	data = anArray ifFalse: [^false].
	^true   ! !

!PrologPredicate methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 13:21'!
predicateName
	^ predicateName! !

!PrologPredicate methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:10'!
predicateName: aSymbol 
	predicateName := aSymbol ! !

PrologPredicate subclass: #Rule
	instanceVariableNames: 'dataSize definitionClosure knowledgeBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

!Rule classSide methodsFor: 'instance creation' stamp: 'HwaJong 10/23/2012 14:05'!
knowledgeBase: aPrologKnowledgeBase predicateName: aSymbol dataSize: anInteger definition: aBlockClosure 
	^self new
		knowledgeBase: aPrologKnowledgeBase;
		predicateName: aSymbol;
		dataSize: anInteger;
		definitionClosure: aBlockClosure
! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/23/2012 14:07'!
compute
	TTTMultiDimensionalDo new
		domains: (Array new: (definitionClosure numArgs) withAll: (knowledgeBase flatGrandDomain asArray));
		block: [:params| (definitionClosure valueWithArguments: params) ifTrue: [knowledgeBase fact: predicateName data: (params first: self dataSize) copy] ];
		run.! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:06'!
dataSize
^dataSize isNil
	ifTrue: [definitionClosure numArgs]
	ifFalse: [dataSize]! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:02'!
dataSize: anInteger 
	dataSize := anInteger! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:03'!
definitionClosure: aBlockClosure 
definitionClosure := aBlockClosure! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/23/2012 14:05'!
knowledgeBase: aPrologKnowledgeBase 
knowledgeBase := aPrologKnowledgeBase! !

Object subclass: #PrologVariable
	instanceVariableNames: 'collectedCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-QueryWhat'!

!PrologVariable methodsFor: 'testing' stamp: 'HwaJong 10/22/2012 17:01'!
isPrologVariable
^true! !

Object subclass: #QueryWhat
	instanceVariableNames: 'knowledgeBase queryFact collectedCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-QueryWhat'!

!QueryWhat classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 18:51'!
knowledgeBase: aPrologKnowledgeBase predicateName: aSymbol data: anArray 
|q3 v|
v := PrologVariable new.
q3 := self new
	knowledgeBase: aPrologKnowledgeBase;
	queryFact: (Fact factName: aSymbol data: (anArray collect: [:each| each representsPrologVariable ifTrue: [v] ifFalse: [each]])).
^q3.

! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 16:48'!
collectResultFromArray: anArray 
self collectedCases addLast: (self queryIndicies collect: [:index| anArray at: index])! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 16:45'!
collectedCases
collectedCases ifNil: [collectedCases := OrderedCollection new].
^collectedCases ! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 16:38'!
knowledgeBase: aPrologKnowledgeBase 
knowledgeBase := aPrologKnowledgeBase ! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 16:38'!
queryFact: aFact 
queryFact := aFact ! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 17:01'!
queryIndicies
^(1 to: queryFact data size) select: [:index| (queryFact data at: index) isPrologVariable ].! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 17:01'!
run

| md anArray aSymbol |
anArray := queryFact data.
aSymbol := queryFact predicateName.
md := TTTMultiDimensionalDo new
	domains: ((1 to: anArray size) collect: [:index| (anArray at: index) isPrologVariable ifTrue: [knowledgeBase flatGrandDomain asArray] ifFalse: [{anArray at: index}]] );
	block: [:array| (knowledgeBase query: aSymbol data: array)
			ifTrue: [ self collectResultFromArray: array ].
		];
	run.! !

!QueryWhat methodsFor: 'evaluating' stamp: 'HwaJong 10/22/2012 16:52'!
value
self run.
^self collectedCases! !
